
/*
 Example using
 GetSystemTimes Function
 Retrieves system timing information.
 On a multiprocessor system, the values returned are the sum of the
 designated times across all processors.
 
 See docs at:
     http://msdn.microsoft.com/en-us/library/ms724400(VS.85).aspx
 */
 
#define _WIN32_WINNT 0x0501
 
#include <Windows.h>
#include <stdio.h>
#include <time.h>

extern "C" unsigned long GetCPU()
{
   FILETIME idle;
   FILETIME kernal;
   FILETIME user;
   BOOL val = GetSystemTimes(&idle, &kernal, &user);
   
   printf("idle: %ul %ul\n",idle.dwHighDateTime,idle.dwLowDateTime);
   printf("user: %ul %ul\n",user.dwHighDateTime,user.dwLowDateTime);
   
   unsigned long i_kt = kernal.dwHighDateTime << 32 + kernal.dwLowDateTime;
   unsigned long long i_ut = user.dwHighDateTime << 32 + user.dwLowDateTime;
   unsigned long long i_sys = i_kt + i_ut;
   unsigned long long i_idl = idle.dwHighDateTime << 32 + idle.dwLowDateTime;
   //unsigned long long cpu = (i_sys-i_idl)*100 / i_sys;
   cpu = cpu / 100;
   return cpu;
}

void wait_s (unsigned n_sec)
{
    time_t sec0 = time(0);
    time_t end0 = sec0 + n_sec;
    time_t t;
    do {
        t = time(0);
    } while (t < end0);
}

int main()
{
  LPFILETIME lpIdleTime;
  LPFILETIME lpKernelTime;
  LPFILETIME lpUserTim;
  
  unsigned long t0 = GetCPU();
  wait_s(1); // wait 1s
  unsigned long t1 = GetCPU();
  printf("Elapsed: %ul\n",t1 - t0);
  
  system("pause");
  return 0;
  
  if (GetSystemTimes(lpIdleTime,lpKernelTime,lpUserTim)) {
     printf("%d",sizeof(lpIdleTime));
     } else fprintf(stderr,"ERROR!\n");
}
