/*
 Example using
 QueryPerformanceCounter Function  Retrieves system timing information.
 
 See docs at:
     http://msdn.microsoft.com/en-us/library/ms644904(VS.85).aspx
 */
 
//#define _WIN32_WINNT 0x0501
 
#include <Windows.h>
#include <stdio.h>
#include <time.h>

void wait_s (unsigned n_sec)
{
    time_t sec0 = time(0);
    time_t end0 = sec0 + n_sec;
    time_t t;
    do {
        t = time(0);
    } while (t < end0);
}

int main()
{
    LARGE_INTEGER t0, t1;
    if (QueryPerformanceCounter(&t0)) {
       wait_s(1);
       QueryPerformanceCounter(&t1);
       printf("t0 = %ul\n",t0.QuadPart);
       printf("t1 = %ul\n",t1.QuadPart);
       unsigned long long i0 = t0.QuadPart;
       unsigned long long i1 = t1.QuadPart;
       if (i1 > i0) i1 -= i0; else i1 = i0 - i1;
       printf("diff = %ul\n",(long)i1);
    }
    system("Pause");
}


